<?php
/**
 * Base Class that a metabox should extend
 */
if(!class_exists("Pdr_Metabox_AttributionLocation")){
	class Pdr_Metabox_AttributionLocation extends Pdr_Metabox{

		/*
		 * Render the metabox (should be over-written by child)
		 */
		public function render($post)
		{
			$vals = get_post_custom($post->ID);
			$attrVal = isset($vals['pdrp_attributionLocation']) ? $vals['pdrp_attributionLocation'][0] : get_option('pdrp_defaultAttributionLocation', 'end');
			$extVal = isset($vals['pdrp_attributionExtended']) ? $vals['pdrp_attributionExtended'][0] : get_option('pdrp_defaultAttributionExtended', '1');
			echo '
				<label class="unc_mbox_label" style="display:block; margin-top:12px;">
					Where should PhotoDropper put photo attributions in this post?
				</label>
				<select id="pdrp_attributionLocation" name="pdrp_attributionLocation" style="margin-top:9px; width:200px;">
					<option value="caption" ' . selected($attrVal, 'caption', 0) . '>In Photo Captions</option>
					<option value="end" ' . selected($attrVal, 'end', 0) . '>At the End of the Post</option>
					<option value="tag" ' . selected($attrVal, 'tag', 0) . '>Use PhotoDropper PHP Tag</option>
				</select>
				<a href="http://www.photodropper.com/wordpress-plugin#php" style="display:none" target="_blank" id="pdrp_phpTagHelp">Click for help using the PHP Tag</a>
				<label class="unc_mbox_label" style="display:block; margin-top:12px;">
					Include Reference to PhotoDropper
				</label>
				<select id="pdrp_attributionExtended" name="pdrp_attributionExtended" style="margin-top:9px; width:200px;">
					<option value="1" ' . selected($extVal, '1', 0) . '>Yes</option>
					<option value="0" ' . selected($extVal, '0', 0) . '>I\'ll share the love another way</option>
				</select>
				<div id="pdrp_shareButtonsInMetabox" style="display:none">' ; 
			?>
				<div id="pdrp_meta_twitter_share" class="pdrp_meta_share">
					<a href="https://twitter.com/share" class="twitter-share-button" data-url="http://www.photodropper.com" data-via="photodropper" data-related="nickreese,imaginicky" data-count="none">Tweet</a>
					<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="//platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>
				</div>
				<div id="pdrp_meta_google_share" class="pdrp_meta_share">
				<!-- Place this tag where you want the +1 button to render -->
				<g:plusone size="medium" annotation="none" href="http://www.photodropper.com"></g:plusone>
				<!-- Place this render call where appropriate -->
				<script type="text/javascript">
				  (function() {
					var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;
					po.src = 'https://apis.google.com/js/plusone.js';
					var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);
				  })();
				</script>
				</div>
				<div id="pdrp_meta_facebook_share" class="pdrp_meta_share">
					<div id="fb-root"></div>
					<div class="fb-like" data-href="http://www.photodropper.com" data-send="false" data-width="50" data-show-faces="false" data-font="verdana"></div>
					<script>(function(d, s, id) {
					  var js, fjs = d.getElementsByTagName(s)[0];
					  if (d.getElementById(id)) return;
					  js = d.createElement(s); js.id = id;
					  js.src = "//connect.facebook.net/en_US/all.js#xfbml=1&appId=351407478235613";
					  fjs.parentNode.insertBefore(js, fjs);
					}(document, 'script', 'facebook-jssdk'));</script>
					<meta property="og:title" content="PhotoDropper" />
					<meta property="og:type" content="website" />
					<meta property="og:url" content="http://www.photodropper.com" />
					<meta property="og:image" content="http://www.photodropper.com/images/PhotoDropper-Logo.png" />
					<meta property="og:site_name" content="PhotoDropper" />
					<meta property="fb:admins" content="577191003,5122346" />
				</div>
				<div class="clear"></div>
			<?php
			echo '
				</div>
			';
		}

		/**
		 * Save function (should be over-written by child)
		 */
		public function save($post_id)
		{
			update_option('pdrp_defaultAttributionLocation', esc_attr($_POST['pdrp_attributionLocation']));
			update_option('pdrp_defaultAttributionExtended', esc_attr($_POST['pdrp_attributionExtended']));
			update_post_meta($post_id, 'pdrp_attributionLocation', esc_attr($_POST['pdrp_attributionLocation']));
			update_post_meta($post_id, 'pdrp_attributionExtended', esc_attr($_POST['pdrp_attributionExtended']));
		}
	}
}

$pdr_mbox_AttributionLocation = new Pdr_Metabox_AttributionLocation(
	array(
		"id" => "unc_mbox-attributionLocation",
		"title" => "Photo Attribution Location",
		"context" => "side",
		"priority" => "default",
		"types" => array("post", "page")
	)
);

